import java.awt.*;
import java.io.*;
import java.security.*;
import au.net.aba.crypto.provider.ABAProvider;
import au.net.aba.crypto.*;
import java.security.spec.*;
import java.security.cert.*;
import sun.security.x509.*;
import javax.crypto.*;
import javacard.*;

public class OpenDialog extends Dialog {

	public OpenDialog(SmartWallet parent, boolean modal)
	{
		super((Frame)parent, modal);
		this.parent = parent;
		
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(346,368);
		setVisible(false);
		btnOpen.setLabel("Open");
		add(btnOpen);
		btnOpen.setBounds(108,312,66,27);
		btnCancel.setLabel("Cancel");
		add(btnCancel);
		btnCancel.setBounds(192,312,66,27);
		panel1.setLayout(null);
		add(panel1);
		panel1.setBounds(24,84,300,218);
		btnDelete.setLabel("Delete");
		panel1.add(btnDelete);
		btnDelete.setBounds(12,108,61,21);
		label2.setText("Password");
		panel1.add(label2);
		label2.setBounds(24,144,72,24);
		panel1.add(txtPassword);
		txtPassword.setBounds(108,144,160,24);
		txtMsg.setText("Select your ID now ...");
		panel1.add(txtMsg);
		txtMsg.setForeground(java.awt.Color.gray);
		txtMsg.setBounds(24,180,288,24);
		panel1.add(listFile);
		listFile.setBounds(12,12,276,96);
		panel2.setLayout(null);
		add(panel2);
		panel2.setBounds(24,84,312,204);
		label3.setText("User Name");
		panel2.add(label3);
		label3.setBounds(12,60,84,27);
		label4.setText("PIN");
		panel2.add(label4);
		label4.setBounds(12,96,82,30);
		label5.setText("Enter User Name and PIN for your Smartcard :");
		panel2.add(label5);
		label5.setBounds(12,12,264,29);
		panel2.add(txtName);
		txtName.setBounds(120,60,160,26);
		txtName.setEditable(false);
		panel2.add(txtPIN);
		txtPIN.setBounds(120,96,160,26);
		label1.setText("Enter your ID, please ...");
		panel2.add(label1);
		label1.setForeground(java.awt.Color.gray);
		label1.setBounds(12,144,264,24);
		label6.setText("STORAGE MEDIA");
		label6.setAlignment(java.awt.Label.CENTER);
		add(label6);
		label6.setBackground(new java.awt.Color(194,187,198));
		label6.setFont(new Font("Dialog", Font.PLAIN, 14));
		label6.setBounds(24,12,288,24);
		opHardisk.setCheckboxGroup(Group1);
		opHardisk.setState(true);
		opHardisk.setLabel("Hardisk");
		add(opHardisk);
		opHardisk.setBounds(24,48,93,21);
		opSmartcard.setCheckboxGroup(Group1);
		opSmartcard.setLabel("Smartcard");
		add(opSmartcard);
		opSmartcard.setBounds(144,48,84,24);
		setTitle("SmartWallet - Open ID");
		setResizable(false);
		//}}
        
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		btnOpen.addActionListener(lSymAction);
		btnCancel.addActionListener(lSymAction);
		btnDelete.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		opHardisk.addItemListener(lSymItem);
		opSmartcard.addItemListener(lSymItem);
		//}}
		loadFile();
	}
    
	public OpenDialog(SmartWallet parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
                Dimension d = getSize();

		super.addNotify();

		// Only do this once.
		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}

		// Used for addNotify check.
		fComponentsAdjusted = true;
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = getParent().getBounds();
    		Rectangle abounds = getBounds();

    		setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    			 bounds.y + (bounds.height - abounds.height)/2);
	    }

		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button btnOpen = new java.awt.Button();
	java.awt.Button btnCancel = new java.awt.Button();
	java.awt.Panel panel1 = new java.awt.Panel();
	java.awt.Button btnDelete = new java.awt.Button();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.TextField txtPassword = new java.awt.TextField();
	java.awt.Label txtMsg = new java.awt.Label();
	java.awt.List listFile = new java.awt.List();
	java.awt.Panel panel2 = new java.awt.Panel();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.TextField txtName = new java.awt.TextField();
	java.awt.TextField txtPIN = new java.awt.TextField();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Checkbox opHardisk = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group1 = new java.awt.CheckboxGroup();
	java.awt.Checkbox opSmartcard = new java.awt.Checkbox();
	//}}

 	// special for parent
 	SmartWallet parent;
 	//create object from class smartcard
  javacard.smartcard card = new javacard.smartcard();
  //for select media
  int mediaType=0;
  // Used for addNotify check.
	boolean fComponentsAdjusted = false;
	// asimetric key
	PrivateKey privkey;
	java.security.cert.Certificate certificate;
	// personal identification
	String myname, mypayment, mycard, mynumber, myexpiry;
	// definisikan tanggal
	String theMonth[] = {"January","February","March","April","May",
		"June","July","August","September","October","November","December"};
	// simpan lokasi user home
	String myhome = System.getProperty("user.home") + File.separator;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == btnOpen)
				btnOpen_ActionPerformed(event);
			else if (object == btnCancel)
				btnCancel_ActionPerformed(event);
			else if (object == btnDelete)
				btnDelete_ActionPerformed(event);
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == OpenDialog.this)
				OpenDialog_WindowClosing(event);
		}
	}

	void OpenDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}

	void btnCancel_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == opHardisk)
				opHardisk_ItemStateChanged(event);
			else if (object == opSmartcard)
				opSmartcard_ItemStateChanged(event);
		}
	}

	void opHardisk_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		if (opHardisk.getState()==true) {
		    panel1.setVisible(true);
		    mediaType = 0;
		    parent.mediaType = 0;
		}
	}

	void opSmartcard_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		if (opSmartcard.getState()==true) {
		    panel1.setVisible(false);
		    mediaType = 1;
		    parent.mediaType = 1;
		}
	}

	void btnOpen_ActionPerformed(java.awt.event.ActionEvent event)
	{
			String bulan, tahun;
			
	    if (mediaType == 1) {
				
				if ((txtPIN.getText()).equals("")) {
					txtMsg.setText("You must fill the PIN !");
					return;
				}
 		    
 		    System.out.println ("Searching for the ASEDrive...");
 		    card.drive_Init ();
 
            System.out.println("Turn the card's power on...");
 		    char[] reset = card.card_On ();
 
		    try {
			    // penting : file harus dibuka lebih dahulu sebelum ditulis
			    // nomor file=1, tipe=0 (ordinary)
			    card.open_File((short)1, (short)0);

			    // recordNumber, offset , datalength
			    // baca nama
			    String header = card.read_File((short)1, (short)0, (short)3);
			    myname = card.read_File((short)2, (short)0, (short)20);
			    txtName.setText(myname);
					parent.txtName.setText(myname);
					// baca jenis pembayaran
			    mypayment = card.read_File((short)3, (short)0, (short)20);
					parent.txtPayment.setText(mypayment);
					// baca nama kartu
			    mycard = card.read_File((short)4, (short)0, (short)20);
					parent.txtCard.setText(mycard);
					// baca nomor kartu
			    mynumber = card.read_File((short)5, (short)0, (short)20);
					parent.txtCardNo.setText(mynumber);
					// baca expiration date
			    myexpiry = card.read_File((short)6, (short)0, (short)6);
					bulan = theMonth[Integer.parseInt(myexpiry.substring(0,1))];
					tahun = myexpiry.substring(2,6);
					parent.txtCardExpiry.setText(bulan + " " + tahun);

			    System.out.println("Turn the card's power off...");
 			    card.card_Off();

		    } catch(Exception e) {System.out.println(e);}
	    }
	    else {
				if (listFile.getSelectedItem()==null) {
					txtMsg.setText("Select your wallet information !");
					return;
				}
				if ((txtPassword.getText()).equals("")) {
					txtMsg.setText("You must fill the password !");
					return;
				}

	    	try {
	    		String data, header;
					String strList = (listFile.getSelectedItem()).trim();
		      byte[] plainData = new byte[89];
		      FileInputStream input = new FileInputStream(myhome + strList + ".swt");
		      int len;
		      
		      if (input.available() != 0) {
		        // baca dari file taruh ke string
		        len = input.read(plainData);
		        data = new String(plainData);
		        // baca header
		        header = (data.substring(0,2));
		        // baca nama
						myname = (data.substring(3,22)).trim();
						parent.txtName.setText(myname);
				    // baca jenis pembayaran
				    mypayment = (data.substring(23,42)).trim();
						parent.txtPayment.setText(mypayment);
						// baca nama kartu
						mycard = (data.substring(43,62)).trim();
						parent.txtCard.setText(mycard);
						// baca nomor kartu
						mynumber = (data.substring(63,82)).trim();
						parent.txtCardNo.setText(mynumber);
						// baca expiration date
						myexpiry = data.substring(83);
						bulan = theMonth[Integer.parseInt(myexpiry.substring(0,1))];
						tahun = myexpiry.substring(2);
						parent.txtCardExpiry.setText(bulan + " " + tahun);

			      certificate = readCert(myhome + strList + ".cer");
			      privkey = readPrivKey(myhome + strList + ".key");
			      parent.certificate = certificate;
			      parent.privkey = privkey;
	      	} else txtMsg.setText("File is empty !");

		      input.close();

		    } catch(Exception e) { 
		        System.err.println("Caught exception: " + e.toString());
		    }
		}
		parent.isOpen = true;
		btnCancel_ActionPerformed(event);
	}

	void btnDelete_ActionPerformed(java.awt.event.ActionEvent event) {
		if (listFile.getSelectedItem()==null) {
			txtMsg.setText("Select your wallet information !");
			return;
		}
		if ((txtPassword.getText()).equals("")) {
			txtMsg.setText("You must fill the password !");
			return;
		}

		String strList = (listFile.getSelectedItem()).trim();
		listFile.remove(strList);

		File ff1 = new File(myhome + strList + ".swt");
		File ff2 = new File(myhome + strList + ".key");
		File ff3 = new File(myhome + strList + ".cer");
		ff1.delete();
		ff2.delete();
		ff3.delete();
	}
	
	// buka file di direktori home terus di taruh ke list
	void loadFile() {
		int i=0;
		File fm = new File(myhome);
		
		String files[] = fm.list(new FilenameFilter() {
			public boolean accept(File dir, String name) {
				if ((name.substring(name.length()-3)).equals("swt")) return true;
				return false;
			}
		});
		
		if (files.length > 0) {
			while (i < 	files.length) {
				listFile.add(files[i].substring(0,files[i].length()-4));
				i++;
			}
		}
	}

	java.security.cert.Certificate readCert(String filename) {
    X509Certificate cert;
    try {

			InputStream in = new FileInputStream(filename);
			CertificateFactory cf = CertificateFactory.getInstance("X.509");
			cert = (X509Certificate)cf.generateCertificate(in);
			in.close();

    } catch (Exception e) {
      System.err.println("Caught exception: " + e.toString());
      return null;
    }
    return cert;
  }

  PrivateKey readPrivKey(String filename) {
    PrivateKey priv;
    try {

			InputStream in = new FileInputStream(filename);
      byte[] encKey = new byte[in.available()];
      in.read(encKey);
      in.close();

      KeyFactory factory = KeyFactory.getInstance("RSA", "ABA");
      PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(encKey);
      priv = factory.generatePrivate(keySpec);
    } catch (Exception e) {
      System.err.println("Caught exception: " + e.toString());
      return null;
    }
    return priv;
  }

}