import java.awt.*;
import java.io.*;
import java.security.*;
import java.util.Calendar;
import au.net.aba.crypto.*;
import au.net.aba.crypto.provider.ABAProvider;
import javax.crypto.*;
import sun.security.util.BigInt;
import java.security.cert.X509Certificate;
import digsec.set.payment.component.CurrencyAmount;
import digsec.set.payment.component.InstallRecurData;
import digsec.set.payment.component.Recurring;
import digsec.set.payment.component.HODInput;


public class SmartWallet extends Frame
{
	// informasi pembelian
  String date, merchant, desc, total, transid;
  int bulan, tahun;
	// kunci privat
	PrivateKey privkey;
	// sertifikat konsumen
	java.security.cert.Certificate certificate;

	public SmartWallet()
	{
		//AccessController.doPrivileged(new PrivilegedAction() {
    //	public Object run() {
				Security.addProvider(new ABAProvider());
    //  	return null; // nothing to return
    //  }
    //});

		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(new java.awt.Color(216,209,184));
		setSize(584,395);
		setVisible(false);

		txtMerchant.setText("MERCHANT");
		txtMerchant.setAlignment(java.awt.Label.CENTER);
		txtMerchant.setBackground(new java.awt.Color(194,187,198));
		txtMerchant.setFont(new Font("Dialog", Font.BOLD, 15));
		txtMerchant.setBounds(12,12,564,27);
		add(txtMerchant);
		cmdTransact.setLabel("Transaction");
		cmdTransact.setBounds(192,348,84,24);
		add(cmdTransact);
		cmdExit.setLabel("Exit");
		cmdExit.setBounds(300,348,86,24);
		add(cmdExit);
		label4.setText("   RECEIPT");
		label4.setFont(new Font("Dialog", Font.BOLD, 12));
		label4.setBounds(12,156,96,24);
		add(label4);
		label3.setText("   PAID WITH");
		label3.setFont(new Font("Dialog", Font.BOLD, 12));
		label3.setBounds(276,84,108,24);
		add(label3);
		label1.setText("   INVOICE");
		label1.setFont(new Font("Dialog", Font.BOLD, 12));
		label1.setBounds(12,84,96,24);
		add(label1);
		label2.setText("   SHIP TO");
		label2.setFont(new Font("Dialog", Font.BOLD, 12));
		label2.setBounds(12,120,96,24);
		add(label2);
		label5.setText("  CARD NO");
		label5.setFont(new Font("Dialog", Font.BOLD, 12));
		label5.setBounds(276,120,108,24);
		add(label5);
		txtTotal.setText("Order Total US$20");
		txtTotal.setForeground(java.awt.Color.gray);
		txtTotal.setBounds(108,84,168,24);
		add(txtTotal);
		txtName.setText("[None]");
		txtName.setForeground(java.awt.Color.gray);
		txtName.setBounds(108,120,173,24);
		add(txtName);
		txtCard.setText("[None]");
		txtCard.setForeground(java.awt.Color.gray);
		txtCard.setBounds(396,84,120,24);
		add(txtCard);
		txtCardNo.setText("[None]");
		txtCardNo.setForeground(java.awt.Color.gray);
		txtCardNo.setBounds(396,120,126,24);
		add(txtCardNo);
		textArea1.setEditable(false);
		textArea1.setText("PROPOSED FOR ORDER DESCRIPTION");
		textArea1.setForeground(java.awt.Color.gray);
		textArea1.setBounds(24,192,540,132);
		add(textArea1);
		label10.setText("   DATE/TIME");
		label10.setFont(new Font("Dialog", Font.BOLD, 12));
		label10.setBounds(12,48,96,24);
		add(label10);
		txtDate.setText("June 1st, 2000");
		txtDate.setForeground(java.awt.Color.gray);
		txtDate.setBounds(108,48,168,24);
		add(txtDate);
		label6.setText("   PAYMENT TYPE");
		label6.setFont(new Font("Dialog", Font.BOLD, 12));
		label6.setBounds(276,48,108,24);
		add(label6);
		txtPayment.setText("[None]");
		txtPayment.setForeground(java.awt.Color.gray);
		txtPayment.setBounds(396,48,122,24);
		add(txtPayment);
		canvas1.setBackground(java.awt.Color.gray);
		canvas1.setBounds(108,72,168,1);
		add(canvas1);
		canvas2.setBackground(java.awt.Color.gray);
		canvas2.setBounds(108,108,168,1);
		add(canvas2);
		canvas3.setBackground(java.awt.Color.gray);
		canvas3.setBounds(108,144,168,1);
		add(canvas3);
		canvas4.setBackground(java.awt.Color.gray);
		canvas4.setBounds(396,72,168,1);
		add(canvas4);
		canvas5.setBackground(java.awt.Color.gray);
		canvas5.setBounds(396,108,167,1);
		add(canvas5);
		canvas6.setBackground(java.awt.Color.gray);
		canvas6.setBounds(396,144,166,1);
		add(canvas6);
		canvas7.setBackground(java.awt.Color.gray);
		canvas7.setBounds(396,180,166,1);
		add(canvas7);
		txtCardExpiry.setText("[None]");
		txtCardExpiry.setForeground(java.awt.Color.gray);
		txtCardExpiry.setBounds(396,156,126,24);
		add(txtCardExpiry);
		label8.setText("  CARD EXPIRY");
		label8.setFont(new Font("Dialog", Font.BOLD, 12));
		label8.setBounds(276,156,108,24);
		add(label8);

		setTitle("SmartWallet v1.0");
		setResizable(false);
		//}}
		
		//{{INIT_MENUS
		menu1.setLabel("Wallet");
		menu1.add(addMenu);
		addMenu.setLabel("Add ID");
		menu1.add(openMenu);
		openMenu.setLabel("Open ID");
		menu1.add(separatorMenuItem);
		separatorMenuItem.setLabel("-");
		menu1.add(exitMenuItem);
		exitMenuItem.setLabel("Exit");
		mainMenuBar.add(menu1);
		menu2.setLabel("View");
		menu2.add(reqMenu);
		reqMenu.setLabel("Certificate");
		mainMenuBar.add(menu2);
		menu3.setLabel("Help");
		menu3.add(tentangMenu);
		tentangMenu.setLabel("About...");
		mainMenuBar.add(menu3);
		//$$ mainMenuBar.move(12,420);
		setMenuBar(mainMenuBar);
		//}}
		
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();

		addMenu.addActionListener(lSymAction);
		openMenu.addActionListener(lSymAction);
		exitMenuItem.addActionListener(lSymAction);
		reqMenu.addActionListener(lSymAction);
		tentangMenu.addActionListener(lSymAction);
		cmdTransact.addActionListener(lSymAction);
		cmdExit.addActionListener(lSymAction);
		//}}
	}

	public SmartWallet(String date, String merchant, String desc, String total, String transid) {
		this();
		this.date = date;
		this.merchant = merchant;
		this.desc = desc;
		this.total = total;
		this.transid = transid;
		txtMerchant.setText(merchant);
		txtTotal.setText("Order Total " + total);
   	textArea1.setText(desc);
		txtDate.setText(date);
  }
	
    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}	
		super.setVisible(b);
	}
	
	static public void main(String args[])
	{
		String date = "June 1st, 2000";
		String merchant = "FASILKOM ONLINE";
		String desc = "THIS IS FOR ORDER DESCRIPTION";
		String total = "3000";
		String transid = "12345678";
		
		try
		{
			//Create a new instance of our application's frame, and make it visible.
    		SmartWallet sw = new SmartWallet(date, merchant, desc, total, transid);
    		sw.setVisible(true);
		}
		catch (Throwable t)
		{
			System.err.println(t);
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}
	
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();
		
		super.addNotify();
	
		if (fComponentsAdjusted)
			return;
	
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}
	
	// Used for addNotify check.
	boolean fComponentsAdjusted = false;
  //for select media
  int mediaType=0;
  boolean isOpen = false;
	
	//{{DECLARE_CONTROLS
	java.awt.Label txtMerchant = new java.awt.Label();
	java.awt.Button cmdTransact = new java.awt.Button();
	java.awt.Button cmdExit = new java.awt.Button();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Label txtTotal = new java.awt.Label();
	java.awt.Label txtName = new java.awt.Label();
	java.awt.Label txtCard = new java.awt.Label();
	java.awt.Label txtCardNo = new java.awt.Label();
	java.awt.TextArea textArea1 = new java.awt.TextArea();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Label txtDate = new java.awt.Label();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label txtPayment = new java.awt.Label();
	java.awt.Canvas canvas1 = new java.awt.Canvas();
	java.awt.Canvas canvas2 = new java.awt.Canvas();
	java.awt.Canvas canvas3 = new java.awt.Canvas();
	java.awt.Canvas canvas4 = new java.awt.Canvas();
	java.awt.Canvas canvas5 = new java.awt.Canvas();
	java.awt.Canvas canvas6 = new java.awt.Canvas();
	java.awt.Canvas canvas7 = new java.awt.Canvas();
	java.awt.Label txtCardExpiry = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	//}}
	
	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar = new java.awt.MenuBar();
	java.awt.Menu menu1 = new java.awt.Menu();
	java.awt.MenuItem addMenu = new java.awt.MenuItem();
	java.awt.MenuItem openMenu = new java.awt.MenuItem();
	java.awt.MenuItem separatorMenuItem = new java.awt.MenuItem();
	java.awt.MenuItem exitMenuItem = new java.awt.MenuItem();
	java.awt.Menu menu2 = new java.awt.Menu();
	java.awt.MenuItem reqMenu = new java.awt.MenuItem();
	java.awt.Menu menu3 = new java.awt.Menu();
	java.awt.MenuItem tentangMenu = new java.awt.MenuItem();
	//}}
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SmartWallet.this)
				SmartWallet_WindowClosing(event);
		}
	}
	
	void SmartWallet_WindowClosing(java.awt.event.WindowEvent event)
	{
		try {
			// QuitDialog Create and show as modal
			(new QuitDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == tentangMenu)
				tentangMenu_ActionPerformed(event);
			else if (object == exitMenuItem)
				exitMenuItem_ActionPerformed(event);
			else if (object == cmdExit)
				cmdExit_ActionPerformed(event);
			if (object == openMenu)
				openMenu_ActionPerformed(event);
			if (object == addMenu)
				addMenu_ActionPerformed(event);
			else if (object == reqMenu)
				reqMenu_ActionPerformed(event);
			else if (object == cmdTransact)
				cmdTransact_ActionPerformed(event);
		}
	}
	
	void tentangMenu_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			(new AboutDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void exitMenuItem_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			// QuitDialog Create and show as modal
		    (new QuitDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void cmdExit_ActionPerformed(java.awt.event.ActionEvent event)
	{
		exitMenuItem_ActionPerformed(event);
	}

	void openMenu_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			// OpenDialog Create and show as modal
		    (new OpenDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void addMenu_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			// AddDialog Create and show as modal
			(new AddDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void reqMenu_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			// ReqDialog Create and show as modal
			(new ReqDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void cmdTransact_ActionPerformed(java.awt.event.ActionEvent event) {
		if (isOpen == false) {
			try {
				(new MsgDialog(this, "You must open data !", true)).setVisible(true);
				return;
			} catch (Exception e) {System.err.println(e);}
		}
		
		byte[] od = desc.getBytes();

		try {
			CurrencyAmount cur = new CurrencyAmount(new BigInt(120),new BigInt(Integer.parseInt(total)),new BigInt(1));  
			byte[] odSalt = {1,4,33,2,1,67,88,23,12,8,1,4,33,2,1,67,88,23,12,8};

			Calendar cal = Calendar.getInstance();
			cal.set(tahun,bulan,1);
			Recurring rec = new Recurring(new BigInt(28),cal.getTime());
		
			InstallRecurData install = new InstallRecurData(rec);
		
			HODInput hod = new HODInput(od,cur,odSalt,install);  
			boolean bool = PurchaseReq.processToMerchant(hod, (X509Certificate)certificate);

		} catch(Exception e) {System.out.println(e);}

		try {
			(new MsgDialog(this, "Transaction successfull !", true)).setVisible(true);
		} catch (Exception e) {System.err.println(e);}
	}
}