/**
 * @author Iman Budi Setiawan
 * @version 1.0
 */
import java.io.*;
import java.net.*;
import netscape.javascript.*;
 
public class Wallet extends java.applet.Applet {
	String date, merchant, ipMerchant, desc, total;

	public String connectToMerchant() {
        String id = new String();
        try
        {
            /* koneksi ke OR yang sedang listen */
            Socket M_Socket = new Socket(ipMerchant, 7000);
            System.out.println("Merchant connected");

            /* setelah ada client maka buat pointer ke input streamnya */
						BufferedReader in_engine = new BufferedReader (new InputStreamReader(M_Socket.getInputStream()));
            PrintStream out_engine = new PrintStream (M_Socket.getOutputStream()); 

            try
            {
                boolean done = false;
                while (!done)
                {  
                    /* contoh record yang dikirim ke Consumer */
                    String str = this.desc;

                    if (str == null) done = true;
                    else {
                        /* kirim message ke merchant */
                        System.out.println("Send string to merchant : "+ str);
                        out_engine.println(str + "\n<END>");
                        out_engine.flush();
                        /* dibawah ini tambahan untuk menunggu hasilnya */
                        System.out.println("Waiting for result ...");
                        id = in_engine.readLine();
                        System.out.println("Get result : "+ id);
                        done = true; // agar langsung keluar
                    }
                }
                M_Socket.close();
            }
            catch (Exception e){
                System.out.println("Merchant error : " + e);
                /* tutup koneksi dengan gateway */
                M_Socket.close();
                return null;
            }
        }
        catch (Exception e) {
            System.out.println("Error creating socket with gateway !");
            return null;
        }
        return id;
	}
	
	public void startWallet(String date, String merchant, String ipMerchant, String desc, String total) {

		this.date = date;
		this.merchant = merchant;
		this.ipMerchant = ipMerchant;
		this.desc = desc;
		this.total = total;
		
		try {			
			JSObject win = JSObject.getWindow(this);

			// status informasi baru mulai
			win.eval("window.status='Sending good lists to merchant ...'");
			
			// terima nomor transaksi (TransID)
			String transid = connectToMerchant();

			if (transid != null) {
				// status informasi baru mulai
				win.eval("window.status='Receive Transaction ID ...'");
	
				SmartWallet sw = new SmartWallet(date, merchant, desc, total, transid);
			  sw.setVisible(true);
			
			} else {
				// status informasi baru mulai
				win.eval("window.status='Merchant can't be reach ...'");
			}

    } catch(JSException jse) {System.err.println(jse);}
  }
}