import java.awt.*;
import java.io.*;
import java.security.*;
import au.net.aba.crypto.provider.ABAProvider;
import au.net.aba.crypto.*;
import java.security.spec.*;
import java.security.cert.*;
import sun.security.x509.*;
import javax.crypto.*;
import javacard.*;

public class AddDialog extends Dialog {

	public AddDialog(Frame parent, boolean modal)
	{
		super(parent, modal);

    	//{{INIT_CONTROLS
		setLayout(null);
		setSize(608,494);
		setVisible(false);
		
		label0.setText("Name");
		label0.setBounds(24,48,96,24);
		add(label0);
		label1.setText("Payment Type");
		label1.setBounds(24,72,96,24);
		add(label1);
		label2.setText("Card Name");
		label2.setBounds(312,48,94,29);
		add(label2);
		label3.setText("Card Number");
		label3.setBounds(312,72,90,25);
		add(label3);
		label4.setText("Password / PIN");
		label4.setBounds(24,180,95,28);
		add(label4);
		label5.setText("Private Key & Certificate");
		label5.setBounds(24,372,144,27);
		add(label5);
		opExist.setCheckboxGroup(Group1);
		opExist.setLabel("Generated");
		opExist.setEnabled(false);
		opExist.setBounds(240,372,84,24);
		add(opExist);
		opnExist.setCheckboxGroup(Group1);
		opnExist.setState(true);
		opnExist.setLabel("Not Generated");
		opnExist.setEnabled(false);
		opnExist.setBounds(336,372,108,24);
		add(opnExist);
		label7.setText("PERSONAL IDENTIFIER");
		label7.setAlignment(java.awt.Label.CENTER);
		label7.setBackground(new java.awt.Color(194,187,198));
		label7.setFont(new Font("Dialog", Font.PLAIN, 14));
		label7.setBounds(24,12,564,31);
		add(label7);
		label8.setText("AUTHENTICATION REQUIRED");
		label8.setAlignment(java.awt.Label.CENTER);
		label8.setBackground(new java.awt.Color(194,187,198));
		label8.setFont(new Font("Dialog", Font.PLAIN, 14));
		label8.setBounds(24,144,564,31);
		add(label8);
		label9.setText("KEY MANAGEMENT");
		label9.setAlignment(java.awt.Label.CENTER);
		label9.setBackground(new java.awt.Color(194,187,198));
		label9.setFont(new Font("Dialog", Font.PLAIN, 14));
		label9.setBounds(24,336,564,31);
		add(label9);
		label6.setText("CERTIFICATE INFORMATION");
		label6.setAlignment(java.awt.Label.CENTER);
		label6.setBackground(new java.awt.Color(194,187,198));
		label6.setFont(new Font("Dialog", Font.PLAIN, 14));
		label6.setBounds(24,216,564,31);
		add(label6);
		label10.setText("Organization Unit");
		label10.setBounds(24,252,108,24);
		add(label10);
		label11.setText("Organization Name");
		label11.setBounds(24,276,108,24);
		add(label11);
		label12.setText("Locality Name");
		label12.setBounds(312,252,108,29);
		add(label12);
		label13.setText("State Name");
		label13.setBounds(312,276,108,24);
		add(label13);
		label14.setText("Country");
		label14.setBounds(24,300,108,28);
		add(label14);
		txtMsg.setText("Your input required ...");
		txtMsg.setBounds(24,408,264,24);
		add(txtMsg);
		txtName.setBounds(144,48,160,24);
		add(txtName);
		txtPayment.addItem("Credit Card");
		txtPayment.addItem("Debit Card");
		txtPayment.setBounds(144,72,160,25);
		add(txtPayment);
		txtCard.addItem("American Express");
		txtCard.addItem("Diners Club Card");
		txtCard.addItem("Discover Card");
		txtCard.addItem("JCB Card");
		txtCard.addItem("MasterCard");
		txtCard.addItem("Visa Card");
		txtCard.setBounds(432,48,160,25);
		add(txtCard);
		txtNumber.setBounds(432,72,160,24);
		add(txtNumber);
		txtPassword.setBounds(144,180,160,24);
		add(txtPassword);
		txtOU.setBounds(144,252,160,24);
		add(txtOU);
		txtON.setBounds(144,276,160,24);
		add(txtON);
		txtCO.setBounds(144,300,160,24);
		add(txtCO);
		txtLN.setBounds(432,252,160,24);
		add(txtLN);
		txtSN.setBounds(432,276,160,24);
		add(txtSN);
		btnGenerate.setLabel("Generate Key");
		btnGenerate.setBounds(72,444,96,27);
		add(btnGenerate);
		btnHardisk.setLabel("Save to Hardisk");
		btnHardisk.setBounds(180,444,117,26);
		add(btnHardisk);
		btnSmartcard.setLabel("Save to Smartcard");
		btnSmartcard.setBounds(312,444,132,26);
		add(btnSmartcard);
		btnFinish.setLabel("Finish");
		btnFinish.setBounds(456,444,66,27);
		add(btnFinish);
		label15.setText("Card Expiry");
		label15.setBounds(24,108,96,24);
		add(label15);
		txtExpiry1.addItem("January");
		txtExpiry1.addItem("February");
		txtExpiry1.addItem("March");
		txtExpiry1.addItem("April");
		txtExpiry1.addItem("May");
		txtExpiry1.addItem("June");
		txtExpiry1.addItem("July");
		txtExpiry1.addItem("August");
		txtExpiry1.addItem("October");
		txtExpiry1.addItem("November");
		txtExpiry1.addItem("December");
		txtExpiry1.setBounds(144,108,84,24);
		add(txtExpiry1);
		txtExpiry2.addItem("2000");
		txtExpiry2.addItem("2001");
		txtExpiry2.addItem("2002");
		txtExpiry2.addItem("2003");
		txtExpiry2.addItem("2004");
		txtExpiry2.addItem("2005");
		txtExpiry2.addItem("2006");
		txtExpiry2.addItem("2007");
		txtExpiry2.addItem("2008");
		txtExpiry2.addItem("2009");
		txtExpiry2.addItem("2010");
		txtExpiry2.setBounds(240,108,60,24);
		add(txtExpiry2);
		setTitle("SmartWallet - Add ID");
		setResizable(false);
		//}}
        
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();

		btnFinish.addActionListener(lSymAction);
		btnGenerate.addActionListener(lSymAction);
		btnHardisk.addActionListener(lSymAction);
		btnSmartcard.addActionListener(lSymAction);
		//}}

	}
    
	public AddDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
    Dimension d = getSize();

		super.addNotify();

		// Only do this once.
		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}

		// Used for addNotify check.
		fComponentsAdjusted = true;
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = getParent().getBounds();
    		Rectangle abounds = getBounds();

    		setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    			 bounds.y + (bounds.height - abounds.height)/2);
	    }

		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Label label0 = new java.awt.Label();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.CheckboxGroup Group1 = new java.awt.CheckboxGroup();
	java.awt.Checkbox opExist = new java.awt.Checkbox();
	java.awt.Checkbox opnExist = new java.awt.Checkbox();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Label label11 = new java.awt.Label();
	java.awt.Label label12 = new java.awt.Label();
	java.awt.Label label13 = new java.awt.Label();
	java.awt.Label label14 = new java.awt.Label();
	java.awt.Label txtMsg = new java.awt.Label();
	java.awt.TextField txtName = new java.awt.TextField();
	java.awt.Choice txtPayment = new java.awt.Choice();
	java.awt.Choice txtCard = new java.awt.Choice();
	java.awt.TextField txtNumber = new java.awt.TextField();
	java.awt.TextField txtPassword = new java.awt.TextField();
	java.awt.TextField txtOU = new java.awt.TextField();
	java.awt.TextField txtON = new java.awt.TextField();
	java.awt.TextField txtCO = new java.awt.TextField();
	java.awt.TextField txtLN = new java.awt.TextField();
	java.awt.TextField txtSN = new java.awt.TextField();
	java.awt.Button btnGenerate = new java.awt.Button();
	java.awt.Button btnHardisk = new java.awt.Button();
	java.awt.Button btnSmartcard = new java.awt.Button();
	java.awt.Button btnFinish = new java.awt.Button();
	java.awt.Label label15 = new java.awt.Label();
	java.awt.Choice txtExpiry1 = new java.awt.Choice();
	java.awt.Choice txtExpiry2 = new java.awt.Choice();
	//}}
    
	// create object from class smartcard
  javacard.smartcard card = new javacard.smartcard();
  // Used for addNotify check.
	boolean fComponentsAdjusted = false;
	// used for private key
	PrivateKey privatekey;
	java.security.cert.Certificate certificate;
	// simpan lokasi user home
	String myhome = System.getProperty("user.home") + File.separator;

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == btnFinish)
				btnFinish_ActionPerformed(event);
			else if (object == btnGenerate)
				btnGenerate_ActionPerformed(event);
			else if (object == btnHardisk)
				btnHardisk_ActionPerformed(event);
			else if (object == btnSmartcard)
				btnSmartcard_ActionPerformed(event);
		}
	}

	void btnFinish_ActionPerformed(java.awt.event.ActionEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}


	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == AddDialog.this) {
				closeWindow(event);
			}
		}
	}

	void closeWindow(java.awt.event.WindowEvent event)
	{
		try {
			this.dispose();
		} catch (Exception e) {
		}
	}

	void btnGenerate_ActionPerformed(java.awt.event.ActionEvent event)
	{
		txtMsg.setText("Generating key in process ...");
		generateKeys();
		opExist.setState(true);
		txtMsg.setText("Generating key finished ...");
	}

	String getFixedString(String str, int len) {
		int i = str.length();
		while (i < len) {
			str = str + " ";
			i++;
		}
		return str;
	}

	void btnHardisk_ActionPerformed(java.awt.event.ActionEvent event)
	{
		if (isEmpty() == true) return;

		try {
			txtMsg.setText("Saving data to hardisk ...");

      String strData = "SWT" +
      	getFixedString((txtName.getText()).trim(), 20) +
      	getFixedString((txtPayment.getSelectedItem()).trim(), 20) +
        getFixedString((txtCard.getSelectedItem()).trim(), 20) +
        getFixedString((txtNumber.getText()).trim(), 20) +
        getFixedString((String.valueOf(txtExpiry1.getSelectedIndex())).trim(),2) +
      	getFixedString((txtExpiry2.getSelectedItem()).trim(),4);
			byte[] data = strData.getBytes();
	      
      FileOutputStream dataFos = new FileOutputStream(myhome + txtName.getText() + ".swt");
      dataFos.write(data);
      dataFos.flush();
      dataFos.close();

			// simpan kunci privat
			dumpKey(myhome + txtName.getText() + ".key");
			// simpan sertifikat
			dumpCert(myhome + txtName.getText() + ".cer");

			txtMsg.setText("Saving data to hardisk finished ...");
    } catch (Exception e) {
      System.err.println("Caught exception: " + e.toString());
    }
	}

	void btnSmartcard_ActionPerformed(java.awt.event.ActionEvent event)
	{
		if (isEmpty() == true) return;

 		System.out.println ("Searching for the ASEDrive...");
 		card.drive_Init ();
 
    
		txtMsg.setText("Saving data to smartcard ...");
    System.out.println("Turn the card's power on...");
 		char[] reset = card.card_On ();
 
		try {
			// penting : file harus dibuka lebih dahulu sebelum ditulis
			// nomor file=1, tipe=0 (ordinary)
			card.open_File((short)1, (short)0);

			// recordNumber, offset, datalength, data
			card.write_File((short)1, (short)0, (short)3, "SWT");
			card.write_File((short)2, (short)0, (short)20, txtName.getText());
			card.write_File((short)3, (short)0, (short)20, txtPayment.getSelectedItem());
			card.write_File((short)4, (short)0, (short)20, txtCard.getSelectedItem());
			card.write_File((short)5, (short)0, (short)20, txtNumber.getText());
			String myexpiry = getFixedString((String.valueOf(txtExpiry1.getSelectedIndex())).trim(),2) +
      	getFixedString((txtExpiry2.getSelectedItem()).trim(),4);
			card.write_File((short)6, (short)0, (short)6, myexpiry);

			System.out.println("Turn the card's power off...");
 			card.card_Off();

			txtMsg.setText("Saving data to smartcard finished ...");
		} catch(Exception e) {System.out.println(e);}
	}

	boolean isEmpty() {
		if (((txtName.getText()).trim()).equals("")) {
			txtMsg.setText("Fill Your Name !");
			return true;
		}
		if (((txtNumber.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the Credit Card Number !");
			return true;
		}
		if (((txtPassword.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the Password !");
			return true;
		}
		if (((txtOU.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the Organization Unit !");
			return true;
		}
		if (((txtON.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the Organization Name !");
			return true;
		}
		if (((txtLN.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the Locality Name !");
			return true;
		}
		if (((txtSN.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the State Name !");
			return true;
		}
		if (((txtCO.getText()).trim()).equals("")) {
			txtMsg.setText("Fill the Country Name !");
			return true;
		}
		if (opExist.getState() == false) {
			txtMsg.setText("You must generate a key !");
			return true;
		}
		return false;
	}
	
	private void dumpKey(String filename) throws IOException
  {
    byte[] encPrivKey = privatekey.getEncoded();
    FileOutputStream privFos = new FileOutputStream(filename);
    privFos.write(encPrivKey);
    privFos.flush();
    privFos.close();
  }

	private void dumpCert(String filename)
  	throws IOException, CertificateException
  {
    PrintStream printstream = new PrintStream(new FileOutputStream(filename));
		printstream.write(certificate.getEncoded());
  }
	
  private void generateKeys() {
		try {

			int validity = 360;
	
	    CertAndKeyGen certandkeygen = new CertAndKeyGen("RSA", "MD5WithRSA", "ABA");
	
			String myname = (txtName.getText()).trim();
			String myOU = (txtOU.getText()).trim();
			String myON = (txtON.getText()).trim();
			String myLN = (txtLN.getText()).trim();
			String mySN = (txtSN.getText()).trim();
			String myCO = (txtCO.getText()).trim();
	    X500Name x500name = new X500Name(myname,myOU,myON,myLN,mySN,myCO);
	
	    certandkeygen.generate(1024);
	    privatekey = certandkeygen.getPrivateKey();
	
	    X509Certificate ax509certificate = certandkeygen.getSelfCertificate(x500name, validity * 24 * 60 * 60);

			certificate = (java.security.cert.Certificate)ax509certificate;	

	  } catch (Exception e) {
	    System.err.println("Caught exception: " + e.toString());
	  }
  }
}